// 2018 ReVoL Primer Template
// draw.h
//  
//   
void Initials() {
    //  
    blackground = 0;
    //  
    drawedges = 1;
    //  
    object = USR;
    object = CYL;
    object = BOX;
    //     
    XAngle = 0;
    ZAngle = 0;
    Plane = 800;
    //   
    LX = 160;
    LY = 180;
    LZ = 180;
    //  
    KA = 0.2;
    KD = 0.5;
    KS = 0.3;
    PH = 2;
    //   
    Intens = 50000;
    //  
    IntensA = Intens * KA1 * KA;
    // 
    render = RE_PHONG;  // 
    render = RE_GOURA;  // 
}
//        
point GetViewPoint(double a, double b, double P) {
    a *= PI180;
    b *= PI180;
    double xy = P * sin(b);
    return point(xy * cos(a), xy * sin(a), P * cos(b));
}
//    
void DrawView(HDC hdc) {
    //  
    ViewPoint(ECO, WCO, PointNumber, XAngle, ZAngle, Plane);
    //  
    SimplePerspect(SCO, ECO, PointNumber, Plane);
    //  
    point light(LX, LY, LZ);
    //  
    point view = GetViewPoint(XAngle, ZAngle, Plane);
    // 
    for (int i = 0; i < TriasNumber; i++) {
        if (TRIS[i].normalZ(SCO) < EPS) continue;
        TRIS[i].vectors(WCO, light, view, Intens, IntensA, TRIS);
        if (render == RE_GOURA) {
            TRIS[i].gouraud(hdc, SCO);
        } else if (render == RE_PHONG) {
            TRIS[i].phong(hdc, SCO, Intens, IntensA);
        }
        if (drawedges) {
            TRIS[i].draw_edges(hdc, SCO);
        }
    }
}
