// 2018 ReVoL Primer Template
// render.h
#define _CRT_SECURE_NO_WARNINGS
#define WIN32_LEAN_AND_MEAN
#include "targetver.h"
#include "resource.h"
#include "windows.h"
#include "math.h"
#include <stdio.h>
#include <stdlib.h>
// : 0 , 1 
int blackground = 0;
//  
int drawedges = 0;
//    XY  
int XAngle = 0;
//    Z  
int ZAngle = 0;
//    
int Plane = 800;
//   
int LX = 160, LY = 180, LZ = 180;
//  
double KA = 0.2;
double KD = 0.5;
double KS = 0.3;
double PH = 2;
//   
double Intens = 50000;
//    
double KA1 = 0.01;
//    
double IntensA = Intens * KA1 * KA;
//  
enum objects { BOX = 513, CYL, USR };
//  
objects object = BOX;
//  
enum render_method { RE_GOURA = 544, RE_PHONG };
//  
render_method render = RE_GOURA;
//   
int PointNumber = 0;
//   
int TriasNumber = 0;
//    
#define GDSZ 401
#define GDSX GDSZ + 4
//    
#define GDEC 200
//   
#define CX GDEC
#define CY GDEC
//  
#define D_ANGLE 3
//      
//   Y      
void DrawObjectEdge(HDC hdc, double XA, double YA, double XB, double YB) {
    MoveToEx(hdc, CX + (int)XA, CY - (int)YA, 0);
    LineTo  (hdc, CX + (int)XB, CY - (int)YB);
}
//     
//   Y      
void DrawPixel(HDC hdc, double X, double Y, COLORREF c) {
    SetPixel(hdc, CX + (int)X, CY - (int)Y, c);
}
#include "point.h"
//  
matrix WCO = 0;
matrix ECO = 0;
matrix SCO = 0;
//  
triangs TRIS = 0;
// 
#include "trans.h"
//  
#include "box.h"
#include "cyl.h"
#include "user.h"
//  
point box_matrix_W[BOX_POINTS];
point box_matrix_E[BOX_POINTS];
point box_matrix_S[BOX_POINTS];
point cyl_matrix_W[CYL_POINTS];
point cyl_matrix_E[CYL_POINTS];
point cyl_matrix_S[CYL_POINTS];
point usr_matrix_W[USR_POINTS];
point usr_matrix_E[USR_POINTS];
point usr_matrix_S[USR_POINTS];
//   
triang box_triangs[BOX_TRIANG];
triang cyl_triangs[CYL_TRIANG];
triang usr_triangs[USR_TRIANG];
//  
void Scene() {
    switch (object) {
    case BOX:
        WCO = box_matrix_W;
        ECO = box_matrix_E;
        SCO = box_matrix_S;
        TRIS = box_triangs;
        PointNumber = BOX_POINTS;
        TriasNumber = BOX_TRIANG;
        break;
    case CYL:
        WCO = cyl_matrix_W;
        ECO = cyl_matrix_E;
        SCO = cyl_matrix_S;
        TRIS = cyl_triangs;
        PointNumber = CYL_POINTS;
        TriasNumber = CYL_TRIANG;
        break;
    default:
        WCO = usr_matrix_W;
        ECO = usr_matrix_E;
        SCO = usr_matrix_S;
        TRIS = usr_triangs;
        PointNumber = USR_POINTS;
        TriasNumber = USR_TRIANG;
    }
}
//  
#include "draw.h"
int loaded = 0;
int shift_on = 0;
#define MW 700
#define MH 476
#define GWW 120
#define UWX 10
#define UWX2 UWX + GDSX + GWW + 30
#define UTOP 16
#define STEPL 16
#define STEPE 19
#define STEP2 20
#define STEP3 30
#define LBW 120
#define LBH 17
#define ESW 49
#define ESH 19
#define RSW 100
#define RSH 17
#define ID_AX 1101
#define ID_AZ 1102
#define ID_VP 1103
#define ID_LX 1110
#define ID_LY 1111
#define ID_LZ 1112
#define ID_KA 1113
#define ID_KD 1114
#define ID_KS 1115
#define ID_PH 1116
#define ID_ED 1134
#define ID_BG 1160
#define KEY_TAB 9
#define KEY_SHIFT 16
#define KEY_ESC 27
#define KEY_UP 38
#define KEY_DOWN 40
#define KEY_LEFT 37
#define KEY_RIGHT 39
#define MAXED 32
#define WHEEL 10
HINSTANCE hInst=0;
HWND focused=0, W0=0, W1=0, WC=0, WX=0, WZ=0, WP=0, WL=0, WLX=0, WLY=0, WLZ=0, WKA=0, WKD=0, WKS=0, WPH=0;
HWND WR0=0, WR1=0, WR2=0, WED=0, WJ=0, WBX=0, WCL=0, WUS=0, WBG=0;
HFONT tahoma=0;
HDC CDC=0;
HBITMAP CBMP=0;
HPEN PenB=0, PenW=0;
char buf[MAXED];
void SelectBackground(int newValue) {
    blackground = newValue;
    if (blackground == 0) {
        SelectObject(CDC, GetStockObject(WHITE_BRUSH));
        SelectObject(CDC, PenB);
    } else {
        SelectObject(CDC, GetStockObject(BLACK_BRUSH));
        SelectObject(CDC, PenW);
    }
}
#include "ccreate.h"