// 2018 ReVoL Primer Template
// trans.h
// 
//  
#define PI2 6.283185307179586
//     
#define PI180 0.0174532925199433
/*      
M2   -  
M1   -  
size -  
a    -     XY
b    -      Z
d    -     Plane
*/
void ViewPoint(matrix & M2, matrix M1, int size, double a, double b, double d) {
    a *= PI180;
    b *= PI180;
    double sinA = sin(a);
    double cosA = cos(a);
    double sinB = sin(b);
    double cosB = cos(b);
    double xy = 0;
    for (int i = 0; i < size; i++) {
        xy = M1[i].X * cosA + M1[i].Y * sinA;
        M2[i].X = M1[i].Y * cosA - M1[i].X * sinA;
        M2[i].Y = M1[i].Z * sinB - xy * cosB;
        M2[i].Z = d - xy * sinB - M1[i].Z * cosB;
    }
}
/*      
M2   -  
M1   -  
size -  
d    -    
*/
void SimplePerspect(matrix & M2, matrix M1, int size, double d) {
    for (int i = 0; i < size; i++) {
        M2[i].X = d * M1[i].X / M1[i].Z;
        M2[i].Y = d * M1[i].Y / M1[i].Z;
        M2[i].Z = M1[i].Z;
    }
}
